#pragma once

// clang-format off
template <typename RType>
void matrix_setter(float Ra, float Rb, float Rc, float Rd, float Re, float Rf, float Rg, float Rh, float Rj, float Rk, float Ri, float Ro, float Ag, RType& R)
{
    R.setSMatrixData ({{(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Ra*Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ra*Rb*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ra*Rb*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Ra*Rb*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ra*Rb*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Ra*Rb*Rj*(-(Rd*Rf*(Rg + Rk)) - Rd*Re*(Rf + Rg + Rk) + Rf*Rg*Ro + Rd*(Rf + Rg + Rk)*Ro + Re*(Rf + Rg + Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Ra*Rb*((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Ra*Rb*Rj*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rb*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*(Ag*Ri - Ro) - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk + Rf*(Rg + Rh + Ag*Ri)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),-1 + (2*(Ra + Ri)*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rb*(Ra + Ri)*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rb*(Ra + Ri)*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rb*(Ra + Ri)*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rb*(Ra + Ri)*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rb*(Ra + Ri)*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rb*(Ra + Ri)*Rj*(-((Rf*Rg + Re*(Rf + Rg + Rk))*Ro) + Rd*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk) - (Rf + Rg + Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rb*(Ra + Ri)*(-((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro) + Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rb*(Ra + Ri)*Rj*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(-2*Rc*(Ag*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rd + Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ri*((1 + Ag)*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Re*(Rf + Rg + Rh + Rj)*Rk + Rf*(Rg + Rh + Rj + Ag*Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),1 - (2*Rc*(Ra + Rb + Ri)*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(-(Rd*Re*Rk) + Rg*Rh*Ro + (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(-((Rf*Rg + Re*(Rf + Rg + Rk))*Ro) + Rd*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk) - (Rf + Rg + Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*(-((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro) + Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rc*(Ra + Rb + Ri)*Rj*(-(Rd*(Rf*Rg + Re*(Rf + Rg))) + Rd*(Rf + Rg)*Ro + (Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rd*(Ag*Ri*(Re*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + Rc*Re*((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk) + Rb*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk) + Rf*Rj*(Rh*Rk + Rg*(Rh + Rk)) + Rc*Rf*(Rh*Rk + Rg*(Rh + Rj + Rk))) - Rb*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rd*(Ag*Ri*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + Rc*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk)) + (Ra + Ri)*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Rb*Rd*Ri*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk) + 2*Rd*(Ra + Rb + Ri)*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),-((Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))),(2*Rd*Rf*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri + Ag*Ri))*Rj*Rk - 2*Rd*(Ra*(Rf + Rg)*((Rb + Rc)*Rh + (Rb + Rc + Rh)*Rj) + (Rf + Rg)*(Rc*Rh*Ri + Rb*Rh*(Rc + Ri) + (Rc + Rh)*Ri*Rj + Rb*(Rc + Rh + Ri)*Rj) + Ra*((Rb + Rc)*(Rf + Rg + Rh) + (Rb + Rc + Rf + Rg + Rh)*Rj)*Rk + ((Rf + Rg + Rh)*(Rc*Ri + Rb*(Rc + Ri)) + ((Rc + Rf + Rg + Rh)*Ri + Rb*(Rc + Rf + Rg + Rh + Ri))*Rj)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rd*((1 + Ag)*Rb*Re*Ri*Rj*Rk + Rb*(Rg*Rh*Ri + Rg*(Rh + Ri)*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro + Ra*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Ra*Rb*(Re*Rj*Rk + Rh*Rk*Ro + Rg*(Rh + Rj + Rk)*Ro) + Ra*Rc*(Re*Rj*Rk + Rh*Rk*Ro + Rg*(Rh + Rj + Rk)*Ro) + Rb*Rc*(Re*Rj*Rk + Rh*Rk*Ro + Rg*(Rh + Rj + Rk)*Ro) + Rc*Ri*(Re*Rj*Rk + Rh*Rk*Ro + Rg*(Rh + Rj + Rk)*Ro)))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rd*(Re + Rf)*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri + Ag*Ri))*Rj*Rk - 2*Rd*(Rf*Rh*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri)) + Rf*(Ra*(Rb + Rc + Rh) + (Rc + Rh)*Ri + Rb*(Rc + Rh + Ri))*Rj + (Ra*(Rb + Rc)*Rf + Rc*Rf*Ri + Rb*Rf*(Rc + Ri) + Ra*(Rb + Rc + Rf)*Rj + (Rc + Rf)*Ri*Rj + Rb*(Rc + Rf + Ri)*Rj)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rd*(Ra*(Rb + Rc)*Rj*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk)) + (Rc*Ri + Rb*(Rc + Ri + Ag*Ri))*Rj*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk)) - Ra*((Rb + Rc)*(Rf + Rg)*Rj + (Rb + Rc)*Rf*Rk + (Rb + Rc + Rf)*Rj*Rk)*Ro - ((Rf + Rg)*(Rc*Ri + Rb*(Rc + Ri))*Rj + (Rc*Rf*Ri + Rb*Rf*(Rc + Ri) + (Rc + Rf)*Ri*Rj + Rb*(Rc + Rf + Ri)*Rj)*Rk)*Ro))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rd*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri + Ag*Ri))*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + 2*Rd*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rd*((Rf*Rg + Re*(Rf + Rg))*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri + Ag*Ri))*Rj + (Rf*Rh*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri)) - (Ra*(Rb + Rc)*Rg - Ra*Rf*Rh - Rb*Rf*Rh + (Rc*Rg - Rf*Rh)*Ri + Rb*Rg*(Rc + Ri))*Rj)*Ro))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Re*(Ag*Ri*((Rf + Rg)*((Rb + Rc)*Rd*Rh + (Rb + Rc)*Rd*Rj + (Rb + Rc + Rd)*Rh*Rj) + ((Rb + Rc)*Rd*(Rf + Rg + Rh) + (Rb*(Rd + Rg + Rh) + Rc*(Rd + Rg + Rh) + Rd*(Rf + Rg + Rh))*Rj)*Rk) - Rb*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Re*(Ag*Ri*((Rf + Rg)*(Rc*Rd*Rh + Rd*Rh*Rj + Rc*(Rd + Rh)*Rj) + (Rc*Rd*(Rf + Rg + Rh) + Rc*(Rd + Rg + Rh)*Rj + Rd*(Rf + Rg + Rh)*Rj)*Rk) + (Ra + Ri)*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Rb*Re*Ri*((Rf + Rg)*Rh*Rj + Rd*(Rf + Rg)*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rf + Rg + Rh + Rj)*Rk) + 2*Re*(Ra + Rb + Ri)*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Re*Rj*(Rf*(Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*Rk + Ag*Rb*Ri*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)) - 2*Re*(Ra*(Rf + Rg)*((Rb + Rc)*Rh + (Rb + Rc + Rh)*Rj) + (Rf + Rg)*(Rc*Rh*Ri + Rb*Rh*(Rc + Ri) + (Rc + Rh)*Ri*Rj + Rb*(Rc + Rh + Ri)*Rj) + Ra*((Rb + Rc)*(Rf + Rg + Rh) + (Rb + Rc + Rf + Rg + Rh)*Rj)*Rk + ((Rf + Rg + Rh)*(Rc*Ri + Rb*(Rc + Ri)) + ((Rc + Rf + Rg + Rh)*Ri + Rb*(Rc + Rf + Rg + Rh + Ri))*Rj)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),-((Rb*((1 + Ag)*Ri*Rj*(Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk - Rf*(Rh*Rk + Rg*(Rh + Rk))) + (-(Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj))) - Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Ri*Rj*(Rg*Rh + (Rg + Rh)*Rk) + Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk))*Ro + Rd*(-(Rf*Rg*(Ri*Rj + Rh*(Ri + Rj))) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk - Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk + ((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Re*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) - Rf*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Re*((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro + (Rh*Rj*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(-(Rf*Rg*(Rh + Rj)) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro))) + Ri*(Rc*(Re*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) - Rf*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Re*((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro + (Rh*Rj*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(-(Rf*Rg*(Rh + Rj)) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rj*(Rf*(Rg*Rh + (Rg + Rh)*Rk)*Ro - Re*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro + Rd*(Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk - Rf*(Rg*Rh + (Rg + Rh)*Rk) + ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro))) + Ra*(Rb*(Re*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) - Rf*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Re*((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro + (Rh*Rj*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(-(Rf*Rg*(Rh + Rj)) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rc*(Re*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) - Rf*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Re*((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro + (Rh*Rj*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(-(Rf*Rg*(Rh + Rj)) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rj*(Rf*(Rg*Rh + (Rg + Rh)*Rk)*Ro - Re*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro + Rd*(Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk - Rf*(Rg*Rh + (Rg + Rh)*Rk) + ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))),(-2*Re*(Ri*(Rj*(Rh*Rk + Rg*(Rh + Rk))*(Rd - Ro) + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro)) + Rb*(Rd*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Rd*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk + (1 + Ag)*Ri*Rj*(Rg*Rh + (Rg + Rh)*Rk) - (Rg*Rh*Ri + Rg*(Rh + Ri)*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro)) + Ra*(Rj*(Rh*Rk + Rg*(Rh + Rk))*(Rd - Ro) + Rb*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro) + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Re*(Ri*(Rc*Rf*(Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)) + Rf*Rj*(Rh + Rk)*(Rd - Ro) - Rc*(Rj*Rk + Rf*(Rh + Rj + Rk))*Ro) + Ra*(Rb*Rf*(Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)) + Rc*Rf*(Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)) + Rf*Rj*(Rh + Rk)*(Rd - Ro) - Rb*(Rj*Rk + Rf*(Rh + Rj + Rk))*Ro - Rc*(Rj*Rk + Rf*(Rh + Rj + Rk))*Ro) + Rb*((1 + Ag)*Rf*Ri*Rj*(Rh + Rk) + Rc*Rf*(Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)) + Rd*(-(Ag*Ri*Rj*Rk) + Rf*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk)) - Rc*(Rj*Rk + Rf*(Rh + Rj + Rk))*Ro - (Ri*Rj*Rk + Rf*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk))*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Re*(-(Rf*(Rb*Rc*Rd + Ra*(Rb + Rc)*Rd + (Rb + Rc)*Rd*Ri + Rb*(Rc + Rd)*Rj + Ra*(Rb + Rc + Rd)*Rj + (Rb + Rc + Rd)*Ri*Rj)*Rk) + Ag*Rb*Ri*Rj*(-(Rf*Rk) + Rd*(Rf + Rg + Rk)) + ((Rf + Rg)*(Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*Rj + (Rb*Rc*Rf + Ra*(Rb + Rc)*Rf + (Rb + Rc)*Rf*Ri + Rb*(Rc + Rf)*Rj + Ra*(Rb + Rc + Rf)*Rj + (Rb + Rc + Rf)*Ri*Rj)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Re*(Ag*Rb*Rd*Ri*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Re*(Ri*(Rf*Rh*Rj*(Rd - Ro) + Rc*(Rd*Rf*(Rh + Rj) + Rf*Rh*(Rj - Ro) + Rg*Rj*Ro)) + Rb*(Rd*Rf*Rh*Ri + (1 + Ag)*Rf*Rh*Ri*Rj + Rd*(Ag*Rg*Ri + Rf*(Rh + Ri + Ag*Ri))*Rj + Rg*Ri*Rj*Ro - Rf*Rh*(Ri + Rj)*Ro + Rc*(Rd*Rf*(Rh + Rj) + Rf*Rh*(Rj - Ro) + Rg*Rj*Ro)) + Ra*(Rf*Rh*Rj*(Rd - Ro) + Rb*(Rd*Rf*(Rh + Rj) + Rf*Rh*(Rj - Ro) + Rg*Rj*Ro) + Rc*(Rd*Rf*(Rh + Rj) + Rf*Rh*(Rj - Ro) + Rg*Rj*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rf*(Ag*Ri*(Rb*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Re + Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk) + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Re + Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk) + Rd*Rj*(Rh*Rk + Rg*(Rh + Rk))) + Rb*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Rf*Ri*(Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Re + Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk) + Rd*Rj*(Rh*Rk + Rg*(Rh + Rk))) + 2*Rf*(Ra + Ri)*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rf*(Ag*Rb*Ri*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Re + Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk) + (Ra + Rb + Ri)*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rf*(Re*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*Rk - Ag*Rb*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) + Rg*Rh*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Ro + Rg*(Ra*(Rb + Rc + Rh) + (Rc + Rh)*Ri + Rb*(Rc + Rh + Ri))*Rj*Ro + (Rg + Rh)*(Ri*(Rc + Rj) + Ra*(Rb + Rc + Rj) + Rb*(Rc + Ri + Rj))*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rf*(Ri*(Rj*(Rh*Rk + Rg*(Rh + Rk))*(Rd - Ro) + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro)) + Rb*(Rd*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Rd*((Rg + Rh)*Ri + (Rg + Rh + Ri)*Rj)*Rk + (1 + Ag)*Ri*Rj*(Rg*Rh + (Rg + Rh)*Rk) - (Rg*Rh*Ri + Rg*(Rh + Ri)*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro)) + Ra*(Rj*(Rh*Rk + Rg*(Rh + Rk))*(Rd - Ro) + Rb*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro) + Rc*(Rg*Rh*Rj + Rd*Rg*(Rh + Rj) + (Rg + Rh)*Rj*Rk + Rd*(Rg + Rh + Rj)*Rk - (Rh*Rk + Rg*(Rh + Rj + Rk))*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),-((Rb*((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Rf*(Rg + Rh)*Rk + Re*(-(Rh*Rk) + Rf*(Rh + Rk) - Rg*(Rh + Rk))) + (-(Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)) + Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) + Re*(Rg*Rh*Ri + Rg*(Rh + Ri)*Rj + (Rg + Rh)*Ri*Rk + (Rg + Rh + Ri)*Rj*Rk - Rf*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk)))*Ro + Rd*(Rf*Rg*Rh*Ri + Rf*Rg*(Rh + Ri)*Rj + Rf*(Rg + Rh)*Ri*Rk + Rf*(Rg + Rh + Ri + Ag*Ri)*Rj*Rk + Re*(-(Rg*(Ri*Rj + Rh*(Ri + Rj))) - ((Rg + Rh)*Ri + (Rg + Rh + Ri)*Rj)*Rk + Rf*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk)) - (Rf - Rg)*(Ri*Rj + Rh*(Ri + Rj))*Ro + ((Rg + Rh)*Ri + (Rg + Rh + Ri)*Rj - Rf*(Ri + Rj))*Rk*Ro) + Rc*(Re*Rj*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro + Re*(Rg*(Rh + Rj) + (Rg + Rh + Rj)*Rk - Rf*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(Rj*(Rh + Rk) - (Rh + Rj + Rk)*Ro) + Rd*(-(Re*Rg*(Rh + Rj)) + Rf*(Rh + Rj)*Rk - Re*(Rg + Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) + Rf*Rg*(Rh + Rj + Rk) + (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))) + Ri*(Rj*(-((Rf*Rg*Rh + Rf*(Rg + Rh)*Rk + Re*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)))*Ro) + Rd*(Rf*Rh*Rk + Rf*Rg*(Rh + Rk) + Re*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rk*Ro - Rf*(Rh + Rk)*Ro + Rg*(Rh + Rk)*Ro)) + Rc*(Re*Rj*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro + Re*(Rg*(Rh + Rj) + (Rg + Rh + Rj)*Rk - Rf*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(Rj*(Rh + Rk) - (Rh + Rj + Rk)*Ro) + Rd*(-(Re*Rg*(Rh + Rj)) + Rf*(Rh + Rj)*Rk - Re*(Rg + Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) + Rf*Rg*(Rh + Rj + Rk) + (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))) + Ra*(Rj*(-((Rf*Rg*Rh + Rf*(Rg + Rh)*Rk + Re*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)))*Ro) + Rd*(Rf*Rh*Rk + Rf*Rg*(Rh + Rk) + Re*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rk*Ro - Rf*(Rh + Rk)*Ro + Rg*(Rh + Rk)*Ro)) + Rb*(Re*Rj*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro + Re*(Rg*(Rh + Rj) + (Rg + Rh + Rj)*Rk - Rf*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(Rj*(Rh + Rk) - (Rh + Rj + Rk)*Ro) + Rd*(-(Re*Rg*(Rh + Rj)) + Rf*(Rh + Rj)*Rk - Re*(Rg + Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) + Rf*Rg*(Rh + Rj + Rk) + (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro)) + Rc*(Re*Rj*(-(Rg*Rh) - (Rg + Rh)*Rk + Rf*(Rh + Rk)) + Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro + Re*(Rg*(Rh + Rj) + (Rg + Rh + Rj)*Rk - Rf*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(Rj*(Rh + Rk) - (Rh + Rj + Rk)*Ro) + Rd*(-(Re*Rg*(Rh + Rj)) + Rf*(Rh + Rj)*Rk - Re*(Rg + Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) + Rf*Rg*(Rh + Rj + Rk) + (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))),(2*Rf*(Ri*(Rj*(Rh + Rk)*(Rd*Re - (Rd + Re)*Ro) + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro)) + Rb*((1 + Ag)*Re*Ri*Rj*(Rh + Rk) - (Rh*Ri*Rj + Re*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk)))*Ro + Rd*(Ag*Ri*Rj*Rk + Re*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk)) - (Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk))*Ro) + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro)) + Ra*(Rj*(Rh + Rk)*(Rd*Re - (Rd + Re)*Ro) + Rb*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro) + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rf*(Re*(Rb*Rc*Rd + Ra*(Rb + Rc)*Rd + (Rb + Rc)*Rd*Ri + Rb*(Rc + Rd)*Rj + Ra*(Rb + Rc + Rd)*Rj + (Rb + Rc + Rd)*Ri*Rj)*Rk + Ag*Rb*Ri*Rj*(Re*Rk + Rd*(Rg + Rk)) + (Rg*(Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*Rj - (Rd + Re)*(Ri*(Rc + Rj) + Ra*(Rb + Rc + Rj) + Rb*(Rc + Ri + Rj))*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Rb*Rd*Rf*Ri*(Rh*Rk + Rg*(Rh + Rk)) + 2*Rf*(Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rf*(Ri*(Rh*Rj*(-(Rd*Re) + (Rd + Re)*Ro) + Rc*(-(Re*Rh*Rj) - Rd*(Rh + Rj)*(Re - Ro) + (Rg + Rh)*Rj*Ro + Re*(Rh + Rj)*Ro)) + Rb*(-((1 + Ag)*Re*Rh*Ri*Rj) + (Rg + Rh)*Ri*Rj*Ro + Re*(Ri*Rj + Rh*(Ri + Rj))*Ro + Rd*(Ag*Rg*Ri*Rj - Re*(Ri*Rj + Rh*(Ri + Rj)) + Rh*Ri*Ro + (Rh + Ri)*Rj*Ro) + Rc*(-(Re*Rh*Rj) - Rd*(Rh + Rj)*(Re - Ro) + (Rg + Rh)*Rj*Ro + Re*(Rh + Rj)*Ro)) + Ra*(Rh*Rj*(-(Rd*Re) + (Rd + Re)*Ro) + Rb*(-(Re*Rh*Rj) - Rd*(Rh + Rj)*(Re - Ro) + (Rg + Rh)*Rj*Ro + Re*(Rh + Rj)*Ro) + Rc*(-(Re*Rh*Rj) - Rd*(Rh + Rj)*(Re - Ro) + (Rg + Rh)*Rj*Ro + Re*(Rh + Rj)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rg*(Ag*Ri*(Rd*Rf*Rj*(Rh + Rk) + Rb*Rd*Rf*(Rh + Rj + Rk) + Rc*Rd*Rf*(Rh + Rj + Rk) + Rb*Rj*(Rf*Rh - Re*Rk) + Rc*Rj*(Rf*Rh - Re*Rk)) + Rb*Rj*(-(Rd*Rk*(Re + Rf - Ro)) - Rf*Rh*Ro + Re*Rk*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rg*(Ag*Ri*(Rd*Rf*Rj*(Rh + Rk) + Rc*Rd*Rf*(Rh + Rj + Rk) + Rc*Rj*(Rf*Rh - Re*Rk)) + (Ra + Ri)*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Rb*Rg*Ri*(Rd*Rf*(Rh + Rj + Rk) + Rj*(Rf*Rh - Re*Rk)) + 2*Rg*(Ra + Rb + Ri)*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rg*Rj*((Re + Rf)*(Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*Rk + Ag*Rb*Rf*Ri*(Rh + Rk)) - 2*Rg*(Rf*Rh*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri)) + Rf*(Ra*(Rb + Rc + Rh) + (Rc + Rh)*Ri + Rb*(Rc + Rh + Ri))*Rj + (Ra*(Rb + Rc)*Rf + Rc*Rf*Ri + Rb*Rf*(Rc + Ri) + Ra*(Rb + Rc + Rf)*Rj + (Rc + Rf)*Ri*Rj + Rb*(Rc + Rf + Ri)*Rj)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rg*(Rf*Ri*(Rc*Rj*(Rh + Rk) + Rd*Rj*(Rh + Rk) + Rc*Rd*(Rh + Rj + Rk)) + Rb*Rf*(Rd*Ri*Rj + Rd*Rh*(Ri + Rj) + Rd*(Ri + Rj)*Rk + Rc*Rj*(Rh + Rk) + (1 + Ag)*Ri*Rj*(Rh + Rk) + Rc*Rd*(Rh + Rj + Rk)) + Ra*Rf*(Rb*Rj*(Rh + Rk) + Rc*Rj*(Rh + Rk) + Rd*Rj*(Rh + Rk) + Rb*Rd*(Rh + Rj + Rk) + Rc*Rd*(Rh + Rj + Rk)) - Ra*((Rb + Rc)*Rf*Rh + Rf*(Rb + Rc + Rh)*Rj + (Rb + Rc)*Rf*Rk + (Rb + Rc + Rf)*Rj*Rk)*Ro - Rb*(Rf*Rh*(Rc + Ri) + Rf*(Rc + Rh + Ri)*Rj + Rf*(Rc + Ri)*Rk + (Rc + Rf + Ri)*Rj*Rk)*Ro - Ri*(Rc*Rf*(Rh + Rj) + Rc*(Rf + Rj)*Rk + Rf*Rj*(Rh + Rk))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rg*(Rb*((1 + Ag)*Re*Ri*Rj*(Rh + Rk) + Rd*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk))*(Re - Ro) - (Rh*Ri*Rj + Re*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk)))*Ro + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro)) + Ri*(Rj*(Rh + Rk)*(Rd*Re - (Rd + Re)*Ro) + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro)) + Ra*(Rj*(Rh + Rk)*(Rd*Re - (Rd + Re)*Ro) + Rb*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro) + Rc*(Re*Rj*(Rh + Rk) + Rd*(Rh + Rj + Rk)*(Re - Ro) - (Rh*Rj + Re*(Rh + Rj + Rk))*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(Rb*((1 + Ag)*Ri*Rj*(Rf*Rh*Rk - Rf*Rg*(Rh + Rk) + Re*(Rh*Rk + Rf*(Rh + Rk) - Rg*(Rh + Rk))) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj - Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + (Rg - Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk - Re*((Ri*Rj + Rh*(Ri + Rj))*Rk + Rf*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk)) - Rg*(Rh*(Ri + Rj) + Rj*Rk + Ri*(Rj + Rk))))*Ro + Rd*(-(Rf*Rg*(Ri*Rj + Rh*(Ri + Rj))) + Rf*(Rh*Ri + (Rh + Ri + Ag*Ri)*Rj - Rg*(Ri + Rj))*Rk + Re*((Ri*Rj + Rh*(Ri + Rj))*Rk + Rf*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk) - Rg*(Ri*Rj + Rh*(Ri + Rj) + (Ri + Rj)*Rk)) - ((Rf - Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf - Rg + Rh)*Ri + (Rf - Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Re*Rj*(Rh*Rk + Rf*(Rh + Rk) - Rg*(Rh + Rk)) - Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro - Re*((Rh + Rj)*Rk + Rf*(Rh + Rj + Rk) - Rg*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(-(Rj*(Rh + Rk)) + (Rh + Rj + Rk)*Ro) + Rd*(Re*(Rh + Rj)*Rk + Rf*(Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) - Re*Rg*(Rh + Rj + Rk) - Rf*Rg*(Rh + Rj + Rk) - (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))) + Ri*(Rj*((-(Re*Rh*Rk) - Rf*Rh*Rk - Re*Rf*(Rh + Rk) + Re*Rg*(Rh + Rk) + Rf*Rg*(Rh + Rk))*Ro + Rd*(Re*Rh*Rk + Rf*Rh*Rk + Re*Rf*(Rh + Rk) - Re*Rg*(Rh + Rk) - Rf*Rg*(Rh + Rk) - Rh*Rk*Ro - Rf*(Rh + Rk)*Ro + Rg*(Rh + Rk)*Ro)) + Rc*(Re*Rj*(Rh*Rk + Rf*(Rh + Rk) - Rg*(Rh + Rk)) - Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro - Re*((Rh + Rj)*Rk + Rf*(Rh + Rj + Rk) - Rg*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(-(Rj*(Rh + Rk)) + (Rh + Rj + Rk)*Ro) + Rd*(Re*(Rh + Rj)*Rk + Rf*(Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) - Re*Rg*(Rh + Rj + Rk) - Rf*Rg*(Rh + Rj + Rk) - (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))) + Ra*(Rj*((-(Re*Rh*Rk) - Rf*Rh*Rk - Re*Rf*(Rh + Rk) + Re*Rg*(Rh + Rk) + Rf*Rg*(Rh + Rk))*Ro + Rd*(Re*Rh*Rk + Rf*Rh*Rk + Re*Rf*(Rh + Rk) - Re*Rg*(Rh + Rk) - Rf*Rg*(Rh + Rk) - Rh*Rk*Ro - Rf*(Rh + Rk)*Ro + Rg*(Rh + Rk)*Ro)) + Rb*(Re*Rj*(Rh*Rk + Rf*(Rh + Rk) - Rg*(Rh + Rk)) - Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro - Re*((Rh + Rj)*Rk + Rf*(Rh + Rj + Rk) - Rg*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(-(Rj*(Rh + Rk)) + (Rh + Rj + Rk)*Ro) + Rd*(Re*(Rh + Rj)*Rk + Rf*(Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) - Re*Rg*(Rh + Rj + Rk) - Rf*Rg*(Rh + Rj + Rk) - (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro)) + Rc*(Re*Rj*(Rh*Rk + Rf*(Rh + Rk) - Rg*(Rh + Rk)) - Rh*Rj*Rk*Ro + Rg*Rj*(Rh + Rk)*Ro - Re*((Rh + Rj)*Rk + Rf*(Rh + Rj + Rk) - Rg*(Rh + Rj + Rk))*Ro + Rf*Rh*(Rj*Rk - (Rj + Rk)*Ro) + Rf*Rg*(-(Rj*(Rh + Rk)) + (Rh + Rj + Rk)*Ro) + Rd*(Re*(Rh + Rj)*Rk + Rf*(Rh + Rj)*Rk + Re*Rf*(Rh + Rj + Rk) - Re*Rg*(Rh + Rj + Rk) - Rf*Rg*(Rh + Rj + Rk) - (Rh + Rj)*Rk*Ro - Rf*(Rh + Rj + Rk)*Ro + Rg*(Rh + Rj + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rg*(-(Ra*(Re + Rf)*((Rb + Rc)*Rd + (Rb + Rc + Rd)*Rj)*Rk) - Rb*(Re + Rf)*(Rd*(Rc + Ri) + (Rc + Rd + Ri)*Rj)*Rk - (Re + Rf)*Ri*(Rd*Rj + Rc*(Rd + Rj))*Rk + Ag*Rb*Ri*Rj*(Rd*Rf - (Re + Rf)*Rk) + Ri*(Rc*Rf*Rj + (Rd + Re + Rf)*Rj*Rk + Rc*(Rd + Re + Rf + Rj)*Rk)*Ro + Ra*(Rb*Rf*Rj + Rc*Rf*Rj + (Rd + Re + Rf)*Rj*Rk + Rb*(Rd + Re + Rf + Rj)*Rk + Rc*(Rd + Re + Rf + Rj)*Rk)*Ro + Rb*(Rc*Rf*Rj + Rf*Ri*Rj + (Rd + Re)*Ri*Rk + (Rd + Re + Ri)*Rj*Rk + Rc*(Rd + Re + Rf + Rj)*Rk + Rf*(Ri + Rj)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rg*(Ag*Rb*Rd*Rf*Ri*(Rh + Rk) + (Rb*Rc + Ra*(Rb + Rc) + (Rb + Rc)*Ri)*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rg*((Re + Rf)*Ri*(Rc*Rd*Rh + Rd*Rh*Rj + Rc*(Rd + Rh)*Rj) + Ra*(Re + Rf)*(Rb*Rd*Rh + Rc*Rd*Rh + Rd*Rh*Rj + Rb*(Rd + Rh)*Rj + Rc*(Rd + Rh)*Rj) - Ra*((Rb + Rc)*(Rd + Re + Rf)*Rh + (Rb + Rc)*(Rd + Re)*Rj + (Rb + Rc + Rd + Re + Rf)*Rh*Rj)*Ro - Ri*(Rc*(Rd + Re + Rf)*Rh + (Rd + Re + Rf)*Rh*Rj + Rc*(Rd + Re + Rh)*Rj)*Ro + Rb*((1 + Ag)*(Re + Rf)*Rh*Ri*Rj + Rc*(Re + Rf)*(Rh*Rj + Rd*(Rh + Rj)) - Rc*((Rd + Re + Rf)*Rh + (Rd + Re + Rh)*Rj)*Ro - (Re*Ri*Rj + Rh*Ri*Rj + Re*Rh*(Ri + Rj) + Rf*Rh*(Ri + Rj))*Ro + Rd*(Re*Ri*Rj + (1 + Ag)*Rf*Ri*Rj + Re*Rh*(Ri + Rj) + Rf*Rh*(Ri + Rj) - Ri*Rj*Ro - Rh*(Ri + Rj)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(-2*Rh*(Ag*Ri*(-(Rd*Rf*Rj*Rk) + Rc*Re*Rj*(Rf + Rg + Rk) + Rc*Rf*(Rg*Rj - Rd*Rk)) + Rb*(Rj*(Rf*Rg + Re*(Rf + Rg + Rk))*(Ag*Ri - Ro) + Rd*(-(Ag*Rf*Ri*Rk) + Rf*Rj*(Rg + Rk) + Re*Rj*(Rf + Rg + Rk) - Rj*(Rf + Rg + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rh*(Ra*Rj*(-(Rd*Rf*(Rg + Rk)) - Rd*Re*(Rf + Rg + Rk) + Rf*Rg*Ro + Rd*(Rf + Rg + Rk)*Ro + Re*(Rf + Rg + Rk)*Ro) + Ri*(-(Ag*Rd*Rf*Rj*Rk) + Ag*Rc*Re*Rj*(Rf + Rg + Rk) + Ag*Rc*Rf*(Rg*Rj - Rd*Rk) + Rj*(Rf*Rg + Re*(Rf + Rg + Rk))*Ro - Rd*Rj*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk) - (Rf + Rg + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rh*(Ra*Rj*(-(Rd*Rf*(Rg + Rk)) - Rd*Re*(Rf + Rg + Rk) + Rf*Rg*Ro + Rd*(Rf + Rg + Rk)*Ro + Re*(Rf + Rg + Rk)*Ro) + Ri*Rj*(-(Rd*Rf*(Rg + Rk)) - Rd*Re*(Rf + Rg + Rk) + Rf*Rg*Ro + Rd*(Rf + Rg + Rk)*Ro + Re*(Rf + Rg + Rk)*Ro) - Rb*(Rj*(Rf*Rg + Re*(Rf + Rg + Rk))*(Ag*Ri - Ro) + Rd*(-(Ag*Rf*Ri*Rk) + Rf*Rj*(Rg + Rk) + Re*Rj*(Rf + Rg + Rk) - Rj*(Rf + Rg + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rh*(Ra*(Rb + Rc)*Rj*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk)) + Rb*Rj*(Rc*Rf*(Rg + Rk) + Rc*Re*(Rf + Rg + Rk) + Re*Ri*(Rf + Rg + Rk) + Rf*Ri*(Rg + Rk + Ag*Rk)) - Ra*((Rb + Rc)*(Rf + Rg)*Rj + (Rb + Rc)*Rf*Rk + (Rb + Rc + Rf)*Rj*Rk)*Ro - Rb*((Rf + Rg)*(Rc + Ri)*Rj + Rf*(Rc + Ri)*Rk + (Rc + Rf + Ri)*Rj*Rk)*Ro + Ri*(-(Rf*Rj*Rk*Ro) + Rc*(Rf*Rj*(Rg + Rk) + Re*Rj*(Rf + Rg + Rk) - ((Rf + Rg)*Rj + (Rf + Rj)*Rk)*Ro))))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rf*Rh*(Ra*(Rb + Rc)*Rd + Rc*Rd*Ri + Rb*Rd*(Rc + Ri) + Ra*(Rb + Rc + Rd)*Rj + (Rc + Rd)*Ri*Rj + Rb*(Rc + Rd + Ri + Ag*Ri)*Rj)*Rk + 2*Rh*((Rf + Rg)*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj + (Ra*(Rb + Rc)*Rf + Rc*Rf*Ri + Rb*Rf*(Rc + Ri) + Ra*(Rb + Rc + Rf)*Rj + (Rc + Rf)*Ri*Rj + Rb*(Rc + Rf + Ri)*Rj)*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Re*Rh*(Ra*(Rb + Rc)*Rd + Rc*Rd*Ri + Rb*Rd*(Rc + Ri) + Ra*(Rb + Rc + Rd)*Rj + (Rc + Rd)*Ri*Rj + Rb*(Rc + Rd + Ri + Ag*Ri)*Rj)*Rk - 2*Rh*(-(Rg*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj) + (Rd + Re)*(Ri*(Rc + Rj) + Ra*(Rb + Rc + Rj) + Rb*(Rc + Ri + Rj))*Rk)*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rh*(Ra*(Re + Rf)*((Rb + Rc)*Rd + (Rb + Rc + Rd)*Rj)*Rk + (Re + Rf)*(Rb*Rd*(Rc + Ri) + Rd*Ri*Rj + Rb*(Rc + Rd + Ri + Ag*Ri)*Rj + Rc*Ri*(Rd + Rj))*Rk - Ra*(Rb*Rf*Rj + Rc*Rf*Rj + (Rd + Re + Rf)*Rj*Rk + Rb*(Rd + Re + Rf + Rj)*Rk + Rc*(Rd + Re + Rf + Rj)*Rk)*Ro - (Ri*(Rc*Rf*Rj + (Rd + Re + Rf)*Rj*Rk + Rc*(Rd + Re + Rf + Rj)*Rk) + Rb*(Rc*Rf*Rj + Rf*Ri*Rj + (Rd + Re)*Ri*Rk + (Rd + Re + Ri)*Rj*Rk + Rc*(Rd + Re + Rf + Rj)*Rk + Rf*(Ri + Rj)*Rk))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(Ri*(Rj*((Re*(Rf + Rg)*Rh + Rf*Rg*(Rh - Rk) - Re*(Rf + Rg - Rh)*Rk + Rf*Rh*Rk)*Ro - Rd*(Re*(Rf + Rg)*Rh + Rf*Rg*(Rh - Rk) - Re*(Rf + Rg - Rh)*Rk + Rf*Rh*Rk - (Rf + Rg)*Rh*Ro + (Rf + Rg - Rh)*Rk*Ro)) - Rc*(Re*Rj*((Rf + Rg)*Rh - (Rf + Rg - Rh)*Rk) + Rf*Rj*(Rg*Rh - Rg*Rk + Rh*Rk) - (Rf*Rg*Rh - Rf*Rg*Rj + Rf*Rh*Rj + Rg*Rh*Rj - (Rg - Rh)*(Rf + Rj)*Rk)*Ro + Re*((-Rh + Rj)*Rk + Rf*(-Rh + Rj + Rk) + Rg*(-Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) - Rf*(Rg - Rh + Rj)*Rk - Re*(Rf + Rg - Rh + Rj)*Rk - (Rf + Rg)*(Rh - Rj)*Ro + (Rf + Rg - Rh + Rj)*Rk*Ro))) - Rb*((1 + Ag)*Ri*Rj*(Re*(Rf + Rg)*Rh + Rf*Rg*(Rh - Rk) - Re*(Rf + Rg - Rh)*Rk + Rf*Rh*Rk) - (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj - Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(-(Ri*Rj) + Rh*(Ri + Rj)) - Re*((Rf + Rg - Rh)*Ri + (Rf + Rg - Rh + Ri)*Rj)*Rk - (Rg - Rh)*(Ri*Rj + Rf*(Ri + Rj))*Rk)*Ro + Rd*(Rf*Rg*(-(Ri*Rj) + Rh*(Ri + Rj)) + Re*(Rf + Rg)*(-(Ri*Rj) + Rh*(Ri + Rj)) - Re*((Rf + Rg - Rh)*Ri + (Rf + Rg - Rh + Ri)*Rj)*Rk - Rf*((1 + Ag)*Ri*Rj + Rg*(Ri + Rj) - Rh*(Ri + Rj))*Rk + (-((Rf + Rg)*(-(Ri*Rj) + Rh*(Ri + Rj))) + (Rf + Rg - Rh)*Ri*Rk + (Rf + Rg - Rh + Ri)*Rj*Rk)*Ro) + Rc*(Re*Rj*((Rf + Rg)*Rh - (Rf + Rg - Rh)*Rk) + Rf*Rj*(Rg*Rh - Rg*Rk + Rh*Rk) - (Rf*Rg*Rh - Rf*Rg*Rj + Rf*Rh*Rj + Rg*Rh*Rj - (Rg - Rh)*(Rf + Rj)*Rk)*Ro + Re*((-Rh + Rj)*Rk + Rf*(-Rh + Rj + Rk) + Rg*(-Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) - Rf*(Rg - Rh + Rj)*Rk - Re*(Rf + Rg - Rh + Rj)*Rk - (Rf + Rg)*(Rh - Rj)*Ro + (Rf + Rg - Rh + Rj)*Rk*Ro))) - Ra*(Rj*(-((Re*(Rf + Rg)*Rh + Rf*Rg*(Rh - Rk) - Re*(Rf + Rg - Rh)*Rk + Rf*Rh*Rk)*Ro) + Rd*(Re*(Rf + Rg)*Rh + Rf*Rg*(Rh - Rk) - Re*(Rf + Rg - Rh)*Rk + Rf*Rh*Rk - (Rf + Rg)*Rh*Ro + (Rf + Rg - Rh)*Rk*Ro)) + Rb*(Re*Rj*((Rf + Rg)*Rh - (Rf + Rg - Rh)*Rk) + Rf*Rj*(Rg*Rh - Rg*Rk + Rh*Rk) - (Rf*Rg*Rh - Rf*Rg*Rj + Rf*Rh*Rj + Rg*Rh*Rj - (Rg - Rh)*(Rf + Rj)*Rk)*Ro + Re*((-Rh + Rj)*Rk + Rf*(-Rh + Rj + Rk) + Rg*(-Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) - Rf*(Rg - Rh + Rj)*Rk - Re*(Rf + Rg - Rh + Rj)*Rk - (Rf + Rg)*(Rh - Rj)*Ro + (Rf + Rg - Rh + Rj)*Rk*Ro)) + Rc*(Re*Rj*((Rf + Rg)*Rh - (Rf + Rg - Rh)*Rk) + Rf*Rj*(Rg*Rh - Rg*Rk + Rh*Rk) - (Rf*Rg*Rh - Rf*Rg*Rj + Rf*Rh*Rj + Rg*Rh*Rj - (Rg - Rh)*(Rf + Rj)*Rk)*Ro + Re*((-Rh + Rj)*Rk + Rf*(-Rh + Rj + Rk) + Rg*(-Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) - Rf*(Rg - Rh + Rj)*Rk - Re*(Rf + Rg - Rh + Rj)*Rk - (Rf + Rg)*(Rh - Rj)*Ro + (Rf + Rg - Rh + Rj)*Rk*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rh*(Rd*(Rc*Ri*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk)) + Rb*(Rc*Rf*(Rg + Rk) + Rc*Re*(Rf + Rg + Rk) + Re*Ri*(Rf + Rg + Rk) + Rf*Ri*(Rg + Rk + Ag*Rk))) - (Rc*Ri + Rb*(Rc + Ri))*(Rf*Rg + Rd*(Rf + Rg + Rk) + Re*(Rf + Rg + Rk))*Ro + Ra*(Rb + Rc)*(-((Rf*Rg + Re*(Rf + Rg + Rk))*Ro) + Rd*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk) - (Rf + Rg + Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rh*(Ra*(Rf*Rg + Re*(Rf + Rg))*((Rb + Rc)*Rd + (Rb + Rc + Rd)*Rj) + Rb*(Rf*Rg + Re*(Rf + Rg))*(Rd*(Rc + Ri) + (Rc + Rd + Ri + Ag*Ri)*Rj) + (Rf*Rg + Re*(Rf + Rg))*Ri*(Rd*Rj + Rc*(Rd + Rj)) - Ra*((Rb + Rc)*((Rd + Re)*Rf + (Rd + Re + Rf)*Rg) + ((Rd + Re)*Rf + (Rb + Rc + Rd + Re + Rf)*Rg)*Rj)*Ro - Rb*(((Rd + Re)*Rf + (Rd + Re + Rf)*Rg)*(Rc + Ri) + (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rg*(Rc + Rf + Ri))*Rj)*Ro - Ri*(Rc*Rd*(Rf + Rg) + Rc*Re*(Rf + Rg) + (Rd + Re)*Rf*Rj + (Rd + Re + Rf)*Rg*Rj + Rc*Rg*(Rf + Rj))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rj*(Ag*Rc*Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rd + Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + Rb*((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*(Ag*Ri - Ro) + Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk + Rf*(Rg + Rh + Ag*Ri)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rj*(Ag*Rc*Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rd + Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) + Ra*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Ra*Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rd*Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rj*(Rb*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*(Ag*Ri - Ro) - Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rd*Ri*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rb*Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Re*(Rf + Rg + Rh)*Rk + Rf*(Rg + Rh + Ag*Ri)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Ra*(-((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro) + Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rg + Rh)*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(Rd*Rf*Rk + (Rf + Rg)*Rh*Ro + (Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(Rd*Re*Rk - Rg*Rh*Ro - (Rd + Re + Rg + Rh)*Rk*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(Rd*Rk*(Re + Rf - Ro) + (Rf*Rh - Re*Rk)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(-((Rf*Rg + Re*(Rf + Rg + Rk))*Ro) + Rd*(Rf*(Rg + Rk) + Re*(Rf + Rg + Rk) - (Rf + Rg + Rk)*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (-(Rf*Rg*Rh*Ri) + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(-(Rh*Ri) + (Rh + Ri)*Rj) - (Rg + Rh)*(Rf*Ri - (Rf + Ri)*Rj)*Rk + Re*(-((Rf + Rg + Rh)*Ri) + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro + Rd*(Rf*Rg*Rh*Ri - Rf*Rg*(Rh + Ri)*Rj + Re*(Rf + Rg)*(Rh*Ri - (Rh + Ri)*Rj) + Rf*(Rg + Rh)*Ri*Rk - Rf*(Rg + Rh + Ri + Ag*Ri)*Rj*Rk + Re*((Rf + Rg + Rh)*Ri - (Rf + Rg + Rh + Ri)*Rj)*Rk + (Rf + Rg)*(-(Rh*Ri) + (Rh + Ri)*Rj)*Ro + (-((Rf + Rg + Rh)*Ri) + (Rf + Rg + Rh + Ri)*Rj)*Rk*Ro) + Rc*(Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro - Rf*(Rg*Rj*(Rh + Rk) + Rh*Rj*(Rk - Ro) + Rh*Rk*Ro + Rg*(Rh - Rj + Rk)*Ro) - Re*(Rh*Rj*Rk + Rf*Rj*(Rh + Rk) + Rg*Rj*(Rh + Rk) + (Rh - Rj)*Rk*Ro + Rf*(Rh - Rj + Rk)*Ro + Rg*(Rh - Rj + Rk)*Ro) + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) + Rf*(Rg + Rh - Rj)*Rk + Re*(Rf + Rg + Rh - Rj)*Rk - ((Rf + Rg)*(Rh - Rj) + (Rf + Rg + Rh - Rj)*Rk)*Ro))) + Ri*(Rj*((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)) + Rc*(Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro - Rf*(Rg*Rj*(Rh + Rk) + Rh*Rj*(Rk - Ro) + Rh*Rk*Ro + Rg*(Rh - Rj + Rk)*Ro) - Re*(Rh*Rj*Rk + Rf*Rj*(Rh + Rk) + Rg*Rj*(Rh + Rk) + (Rh - Rj)*Rk*Ro + Rf*(Rh - Rj + Rk)*Ro + Rg*(Rh - Rj + Rk)*Ro) + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) + Rf*(Rg + Rh - Rj)*Rk + Re*(Rf + Rg + Rh - Rj)*Rk - ((Rf + Rg)*(Rh - Rj) + (Rf + Rg + Rh - Rj)*Rk)*Ro))) + Ra*(Rj*((Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rd*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro)) + Rb*(Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro - Rf*(Rg*Rj*(Rh + Rk) + Rh*Rj*(Rk - Ro) + Rh*Rk*Ro + Rg*(Rh - Rj + Rk)*Ro) - Re*(Rh*Rj*Rk + Rf*Rj*(Rh + Rk) + Rg*Rj*(Rh + Rk) + (Rh - Rj)*Rk*Ro + Rf*(Rh - Rj + Rk)*Ro + Rg*(Rh - Rj + Rk)*Ro) + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) + Rf*(Rg + Rh - Rj)*Rk + Re*(Rf + Rg + Rh - Rj)*Rk - ((Rf + Rg)*(Rh - Rj) + (Rf + Rg + Rh - Rj)*Rk)*Ro)) + Rc*(Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro - Rf*(Rg*Rj*(Rh + Rk) + Rh*Rj*(Rk - Ro) + Rh*Rk*Ro + Rg*(Rh - Rj + Rk)*Ro) - Re*(Rh*Rj*Rk + Rf*Rj*(Rh + Rk) + Rg*Rj*(Rh + Rk) + (Rh - Rj)*Rk*Ro + Rf*(Rh - Rj + Rk)*Ro + Rg*(Rh - Rj + Rk)*Ro) + Rd*(Rf*Rg*(Rh - Rj) + Re*(Rf + Rg)*(Rh - Rj) + Rf*(Rg + Rh - Rj)*Rk + Re*(Rf + Rg + Rh - Rj)*Rk - ((Rf + Rg)*(Rh - Rj) + (Rf + Rg + Rh - Rj)*Rk)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rj*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))},{(2*Rk*(Ag*Ri*(Rd*Rf*Rh*Rj + Rb*(Re*(Rf + Rg)*Rj + Rf*(Rg + Rh)*Rj + Rd*Rf*(Rh + Rj)) + Rc*(Re*(Rf + Rg)*Rj + Rf*(Rg + Rh)*Rj + Rd*Rf*(Rh + Rj))) + Rb*Rj*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Ag*Ri*(Rd*Rf*Rh*Rj + Rc*(Re*(Rf + Rg)*Rj + Rf*(Rg + Rh)*Rj + Rd*Rf*(Rh + Rj)))*Rk + 2*(Ra + Ri)*Rj*Rk*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rk*(Ag*Rb*Ri*(Re*(Rf + Rg)*Rj + Rf*(Rg + Rh)*Rj + Rd*Rf*(Rh + Rj)) + (Ra + Rb + Ri)*Rj*(Rd*(Rf*Rg + Re*(Rf + Rg)) - (Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*Ro)))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rk*(Ra*(Rb + Rc)*(Rf*Rg + Re*(Rf + Rg))*Rj + Ra*((Rb + Rc)*Rf*Rh - (Rb + Rc)*Rg*Rj + Rf*Rh*Rj)*Ro + Ri*(Rf*Rh*Rj*Ro + Rc*(Rf*Rg*Rj + Re*(Rf + Rg)*Rj + Rf*Rh*Ro - Rg*Rj*Ro)) + Rb*(Re*(Rf + Rg)*Ri*Rj + Rf*(Rg - Ag*Rh)*Ri*Rj - Rg*Ri*Rj*Ro + Rf*Rh*(Ri + Rj)*Ro + Rc*(Rf*Rg*Rj + Re*(Rf + Rg)*Rj + Rf*Rh*Ro - Rg*Rj*Ro))))/(Ri*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(-(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) - Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*(-((1 + Ag)*Ri*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Rf*Rg*Rh*Ri + Rf*Rg*Rh*Rj + Rf*Rg*Ri*Rj + Rf*Rh*Ri*Rj + Rg*Rh*Ri*Rj + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + (Rg + Rh)*(Rf*Ri + (Rf + Ri)*Rj)*Rk + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(-(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)) + (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro - Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rk*(Rd*Rf*Rh*(Rc*Ri + Rb*(Rc + Ri)) + Rf*(Rb*Rc*Rd + Rb*(Rc + Rd)*Rh + (Rb + Rc)*Rd*Ri + (Rb + Ag*Rb + Rc + Rd)*Rh*Ri)*Rj + Ra*Rf*((Rb + Rc)*Rd*Rh + (Rb + Rc)*Rd*Rj + (Rb + Rc + Rd)*Rh*Rj) - Ra*((Rb + Rc)*Rf*Rh - (Rb + Rc)*Rg*Rj + Rf*Rh*Rj)*Ro - (Rb*Rf*Rh*(Rc + Ri) + Rb*(Rf*Rh - Rg*(Rc + Ri))*Rj + Ri*(Rc*Rf*Rh - Rc*Rg*Rj + Rf*Rh*Rj))*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rk*(Rb*Re*(Rc*Rd*Rh + Rd*Rh*Ri + Rd*Rh*Rj + Rc*(Rd + Rh)*Rj + (Rd + Rh + Ag*Rh)*Ri*Rj) + Ra*Re*(Rb*Rh*Rj + Rc*Rh*Rj + Rd*Rh*Rj + Rb*Rd*(Rh + Rj) + Rc*Rd*(Rh + Rj)) - Ra*((Rb + Rc)*(Rd + Re)*Rh + (Rb + Rc)*(Rd + Re + Rg)*Rj + (Rb + Rc + Rd + Re)*Rh*Rj)*Ro - Rb*((Rd + Re)*Rh*(Rc + Ri) + ((Rd + Re)*Rh + Rc*(Rd + Re + Rg + Rh) + (Rd + Re + Rg + Rh)*Ri)*Rj)*Ro + Ri*(Rh*Rj*(Rd*Re - (Rd + Re)*Ro) + Rc*(Re*Rh*Rj + Rd*(Rh + Rj)*(Re - Ro) - (Re*Rh + (Re + Rg + Rh)*Rj)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(-2*Rk*((Re + Rf)*Ri*(Rc*Rd*Rh + Rd*Rh*Rj + Rc*(Rd + Rh)*Rj) + Rb*(Re + Rf)*(Rc*Rd*Rh + Rd*Rh*Ri + Rd*Rh*Rj + Rc*(Rd + Rh)*Rj + (Rd + Rh + Ag*Rh)*Ri*Rj) + Ra*(Re + Rf)*(Rb*Rh*Rj + Rc*Rh*Rj + Rd*Rh*Rj + Rb*Rd*(Rh + Rj) + Rc*Rd*(Rh + Rj)) - Ra*((Rb + Rc)*(Rd + Re + Rf)*Rh + (Rb + Rc)*(Rd + Re)*Rj + (Rb + Rc + Rd + Re + Rf)*Rh*Rj)*Ro - Ri*(Rc*(Rd + Re + Rf)*Rh + (Rd + Re + Rf)*Rh*Rj + Rc*(Rd + Re + Rh)*Rj)*Ro - Rb*((Rd + Re + Rf)*Rh*(Rc + Ri) + ((Rd + Re + Rf)*Rh + Rc*(Rd + Re + Rh) + (Rd + Re + Rh)*Ri)*Rj)*Ro))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rk*(Ra*(Rf*Rg + Re*(Rf + Rg))*((Rb + Rc)*Rd + (Rb + Rc + Rd)*Rj) + (Rf*Rg + Re*(Rf + Rg))*Ri*(Rd*Rj + Rc*(Rd + Rj)) - Ra*((Rb + Rc)*((Rd + Re)*Rf + (Rd + Re + Rf)*Rg) + ((Rd + Re)*Rf + (Rb + Rc + Rd + Re + Rf)*Rg)*Rj)*Ro - Ri*(Rc*Rd*(Rf + Rg) + Rc*Re*(Rf + Rg) + (Rd + Re)*Rf*Rj + (Rd + Re + Rf)*Rg*Rj + Rc*Rg*(Rf + Rj))*Ro + Rb*((1 + Ag)*Rf*Rg*Ri*Rj + Rc*(Rf*Rg + Re*(Rf + Rg))*(Rd + Rj) - Rc*(Rd*(Rf + Rg) + Re*(Rf + Rg) + Rg*(Rf + Rj))*Ro - Rg*(Ri*Rj + Rf*(Ri + Rj))*Ro + Re*(Rf + Rg)*((1 + Ag)*Ri*Rj - (Ri + Rj)*Ro) + Rd*(Ag*Rf*Ri*Rj + Rf*Rg*(Ri + Rj) + Re*(Rf + Rg)*(Ri + Rj) - (Rf + Rg)*(Ri + Rj)*Ro))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(2*Rd*(Ra*(Rb + Rc)*(Rf*Rg + Re*(Rf + Rg)) + Rc*(Rf*Rg + Re*(Rf + Rg))*Ri + Rb*(Rc*Rf*Rg + Rc*Re*(Rf + Rg) + Re*(Rf + Rg)*Ri + Rf*(Rg - Ag*Rh)*Ri))*Rk - 2*(Rd*(Rf + Rg) + Re*(Rf + Rg) + Rf*(Rg + Rh))*(Ra*(Rb + Rc) + Rc*Ri + Rb*(Rc + Ri))*Rk*Ro)/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)))),(Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh - (Rf + Rg + Rh)*Rk) + Ri*Rj*(-(Rg*Rh) + (Rg + Rh)*Rk)*Ro + Re*(-((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj))) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro + Rd*(Rf*Rg*(Ri*Rj + Rh*(Ri + Rj)) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) - Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk - Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk + (-((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj))) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rf*Rj*(Rg*Rh - (Rg + Rh)*Rk) + (-(Rg*Rh*Rj) - Rf*(Rh*Rj + Rg*(Rh + Rj)) + Rf*(Rg + Rh)*Rk + (Rg + Rh)*Rj*Rk)*Ro + Re*(Rf*Rj*(Rh - Rk) + Rg*Rj*(Rh - Rk) - Rh*Rj*Rk - Rf*(Rh + Rj - Rk)*Ro - Rg*(Rh + Rj - Rk)*Ro + (Rh + Rj)*Rk*Ro) + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk - Re*(Rf + Rg + Rh + Rj)*Rk - (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rf*((1 + Ag)*Rg*Ri*Rj*(Rh - Rk) - Rg*(Ri*Rj + Rh*(Ri + Rj) - (Ri + Rj)*Rk)*Ro + Rh*(Ri*Rk*Ro + Rj*Rk*Ro - Ri*Rj*(Rk + Ag*Rk + Ro)))) + Ri*(Rc*(Rf*Rj*(Rg*Rh - (Rg + Rh)*Rk) + (-(Rg*Rh*Rj) - Rf*(Rh*Rj + Rg*(Rh + Rj)) + Rf*(Rg + Rh)*Rk + (Rg + Rh)*Rj*Rk)*Ro + Re*(Rf*Rj*(Rh - Rk) + Rg*Rj*(Rh - Rk) - Rh*Rj*Rk - Rf*(Rh + Rj - Rk)*Ro - Rg*(Rh + Rj - Rk)*Ro + (Rh + Rj)*Rk*Ro) + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk - Re*(Rf + Rg + Rh + Rj)*Rk - (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rj*((-(Rf*Rg*Rh) - Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rd*(Re*(Rf + Rg)*Rh - Re*(Rf + Rg + Rh)*Rk - Rg*Rh*Ro + (Rg + Rh)*Rk*Ro + Rf*(Rg*(Rh - Rk) + Rk*Ro - Rh*(Rk + Ro))))) + Ra*(Rb*(Rf*Rj*(Rg*Rh - (Rg + Rh)*Rk) + (-(Rg*Rh*Rj) - Rf*(Rh*Rj + Rg*(Rh + Rj)) + Rf*(Rg + Rh)*Rk + (Rg + Rh)*Rj*Rk)*Ro + Re*(Rf*Rj*(Rh - Rk) + Rg*Rj*(Rh - Rk) - Rh*Rj*Rk - Rf*(Rh + Rj - Rk)*Ro - Rg*(Rh + Rj - Rk)*Ro + (Rh + Rj)*Rk*Ro) + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk - Re*(Rf + Rg + Rh + Rj)*Rk - (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rc*(Rf*Rj*(Rg*Rh - (Rg + Rh)*Rk) + (-(Rg*Rh*Rj) - Rf*(Rh*Rj + Rg*(Rh + Rj)) + Rf*(Rg + Rh)*Rk + (Rg + Rh)*Rj*Rk)*Ro + Re*(Rf*Rj*(Rh - Rk) + Rg*Rj*(Rh - Rk) - Rh*Rj*Rk - Rf*(Rh + Rj - Rk)*Ro - Rg*(Rh + Rj - Rk)*Ro + (Rh + Rj)*Rk*Ro) + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) - Rf*(Rg + Rh + Rj)*Rk - Re*(Rf + Rg + Rh + Rj)*Rk - (Rf + Rg)*(Rh + Rj)*Ro + (Rf + Rg + Rh + Rj)*Rk*Ro)) + Rj*((-(Rf*Rg*Rh) - Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro + Rd*(Re*(Rf + Rg)*Rh - Re*(Rf + Rg + Rh)*Rk - Rg*Rh*Ro + (Rg + Rh)*Rk*Ro + Rf*(Rg*(Rh - Rk) + Rk*Ro - Rh*(Rk + Ro))))))/(Ri*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro)) + Ra*(Rc*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk)*Ro - Rc*(Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk - ((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk)*Ro) + Rc*Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro) + Rb*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))) + Rb*((1 + Ag)*Re*Ri*Rj*((Rf + Rg)*Rh + (Rf + Rg + Rh)*Rk) + (1 + Ag)*Rf*Ri*Rj*(Rh*Rk + Rg*(Rh + Rk)) - Rf*(Rg*Rh*Ri + Rg*Rh*Rj + Rg*Ri*Rj + Rh*Ri*Rj + (Rg + Rh)*(Ri + Rj)*Rk)*Ro - Re*((Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro - Ri*Rj*(Rh*Rk + Rg*(Rh + Rk))*Ro + Rd*(Rf*Rg*(Rh*Ri + (Rh + Ri)*Rj) + Re*(Rf + Rg)*(Ri*Rj + Rh*(Ri + Rj)) + Re*((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk + Rf*((Rg + Rh)*Ri + (Rg + Rh + Ri + Ag*Ri)*Rj)*Rk - ((Rf + Rg)*(Rh*Ri + (Rh + Ri)*Rj) + ((Rf + Rg + Rh)*Ri + (Rf + Rg + Rh + Ri)*Rj)*Rk)*Ro) + Rc*(Rj*(Rf*Rg*Rh + Re*(Rf + Rg)*Rh + Rf*(Rg + Rh)*Rk + Re*(Rf + Rg + Rh)*Rk) - (Re*(Rf + Rg)*(Rh + Rj) + Rh*Rj*Rk + Re*(Rf + Rg + Rh + Rj)*Rk + Rg*Rj*(Rh + Rk) + Rf*Rh*(Rj + Rk) + Rf*Rg*(Rh + Rj + Rk))*Ro + Rd*(Rf*Rg*(Rh + Rj) + Re*(Rf + Rg)*(Rh + Rj) + Rf*(Rg + Rh + Rj)*Rk + Re*(Rf + Rg + Rh + Rj)*Rk - ((Rf + Rg)*(Rh + Rj) + (Rf + Rg + Rh + Rj)*Rk)*Ro))))}});
}
// clang-format on
